USACO buylow

  这个题的意思就是求出最长递减子序列的长度以及数量, 第一问很好求, 第二问要求得话会比较麻烦,我们令dp[i]为以i结尾的最长递减子序列的长度,dp1[i]为以i为结尾长度为dp[i]的子序列的个数,因为题意还要求子序列不能重复,现在思考不重复时的情况, 不重复的时候dp1[i]的计算方法是这样的,当dp[i]==1的时候dp1[i]=1, 不等于1的时候自然等于dp1[j]的和, 其中dp[i] = dp[j]+1, a[j]>a[i], 考虑到题意求解不重复的方案数, 因此j转移到i时a[j]不应该有重复,例如5 5 3, 以3结尾的长度为二的子序列个数为1个, 前面两个5里面应该只能选一个,并且应该选后面那个。代码如下:

/*
    ID: m1500293
    LANG: C++
    PROG: buylow
*/
#include <cstdio>
#include <algorithm>
#include <cstring>
#include <set>
#include <iostream>
#include <vector>

using namespace std;
typedef long long LL;
struct BigInteger
{
    static const int BASE = 100000000;    //八位为一基本单位
    static const int WIDTH = 8;
    vector<int> s;

    BigInteger(long long num=0) { *this = num; }
    BigInteger operator = (long long num)
    {
        s.clear();
        do
        {
            s.push_back(num%BASE);
            num /= BASE;
        }while(num > 0);
        return *this;
    }
    BigInteger operator + (const BigInteger& b) const
    {
        BigInteger c;
        c.s.clear();
        for(int i=0, g=0; ;i++)
        {
            if(g==0&&i>=s.size() && i>=b.s.size()) break;
            int x = g;
            if(i < s.size()) x+=s[i];
            if(i < b.s.size()) x += b.s[i];
            c.s.push_back(x%BASE);
            g = x / BASE;
        }
        return c;
    }
    BigInteger operator += (const BigInteger& b)
    {
        *this = *this + b;
        return *this;
    }
    bool operator < (const BigInteger& b) const
    {
        if(s.size() != b.s.size()) return s.size() < b.s.size();
        for(int i=s.size()-1; i>=0; i--)
            if(s[i]!=b.s[i]) return s[i]<b.s[i];
        return false;
    }
    bool operator == (const BigInteger& b) const
    {
        return !(b<*this)&&!(*this<b);
    }
    void print()
    {
        printf("%d", s[s.size()-1]);
        for(int i=s.size()-2; i>=0; i--)
                printf("%08d", s[i]);
        printf("\n");
    }
};
int n;
LL a[5500];
int dp[5500];    //以i为结尾最长下降序列的长度
BigInteger dp1[5500];

int main()
{
    freopen("buylow.in", "r", stdin);
    freopen("buylow.out", "w", stdout);
    scanf("%d", &n);
    for(int i=1; i<=n; i++)
        cin>>a[i];
    dp[1] = 1;
    dp1[1] = 1;
    int res1 = 1;
    set<LL> tp;
    for(int i=2; i<=n; i++)
    {
        tp.clear();
        dp[i] = 1;
        for(int j=1; j<i; j++)
            if(a[i]<a[j]) dp[i] = max(dp[i], dp[j]+1);
        res1 = max(res1, dp[i]);

        if(dp[i]==1)
            dp1[i] = 1;
        else
        {
            for(int j=i-1; j>=1; j--)                //这边注意循环方向 因为可能有a, a, b这种子序列的存在, 查了好久才查出来
                if(dp[i]==dp[j]+1 && a[i]<a[j] && tp.find(a[j])==tp.end())
                {
                    dp1[i] += dp1[j];
                    tp.insert(a[j]);
                }
        }
    }
    BigInteger res2 = 0;
    tp.clear();
    for(int i=n; i>=1; i--)               //注意对于相同的数字选择下标最大的那个, 因为下标最大的子序列包括下标较小的子序列。
    {
        if(dp[i]==res1 && tp.find(a[i])==tp.end())
        {
            res2 += dp1[i];
            tp.insert(a[i]);
        }
    }
    printf("%d ", res1);
    res2.print();
    return 0;
}
时间: 2024-10-13 10:25:29

USACO buylow的相关文章

usaco 4.3 Buy Low, Buy Lower

http://train.usaco.org/usacoprob2?a=7BaJNgFLmpD&S=buylow 求最长递减子序列以及方案数,注意重复不算,比如 3 2 3 2 1 ,这里取到最长递减子序列算一种(3 2 1). 思路: 最长递减子序列的长度可以直接dp: dp[i]=max(dp[j]+1) (j<i&&a[j]<a[i]). 而方案数,如果不重复的话,在dp的过程中记录下就可以求了,设cnt[i]为以a[i]为结尾的方案数,那么推完dp的值之后再推一

算法练习 - Buy Low, Buy Lower - USACO

这道题目本身很简单,倒推回去,第K个是最优时,K+1时必然包含它.所以就从最后面的股票开始贪心法用最优解生成最优解. 难点1是去重,我直接用了个价格表去过滤,如果多个价格相等的同级最优解,就用他们中可能性最大的那个累加,其余的忽略. 难点2是大数计算.可能性可能有几十位的数字,所以封装了一个大数类.现在还不支持符号,只支持正数.后面需要用到负数的时候再说. 题目: Buy Low, Buy Lower The advice to "buy low" is half the formul

COGS 696. [IOI1996][USACO 2.3] 最长前缀

★   输入文件:prefix.in   输出文件:prefix.out   简单对比时间限制:1 s   内存限制:128 MB 描述 USACO 2.3.1 IOI96 在生物学中,一些生物的结构是用包含其要素的大写字母序列来表示的.生物学家对于把长的序列分解成较短的序列(即元素)很感兴趣. 如果一个集合 P 中的元素可以通过串联(元素可以重复使用,相当于 Pascal 中的 “+” 运算符)组成一个序列 S ,那么我们认为序列 S 可以分解为 P 中的元素.元素不一定要全部出现(如下例中B

USACO prefix TrieTree + DP

/* ID:kevin_s1 PROG:prefix LANG:C++ */ #include <iostream> #include <cstdio> #include <string> #include <cstring> #include <vector> #include <map> #include <set> #include <algorithm> #include <cstdlib>

【USACO 1.3.4】牛式

[題目描述 ] 下面是一个乘法竖式,如果用我们给定的那n个数字来取代*,可以使式子成立的话,我们就叫这个式子牛式. * * * x * * ---------- * * * * * * ---------- * * * * 数字只能取代*,当然第一位不能为0,况且给定的数字里不包括0. 注意一下在美国的学校中教的"部分乘积",第一部分乘积是第二个数的个位和第一个数的积,第二部分乘积是第二个数的十位和第一个数的乘积. 写一个程序找出所有的牛式. [格式] INPUT FORMAT: (f

USACO Chapter 1 Section 1.1

USACO的题解和翻译已经很多了... 我只是把自己刷的代码保存一下. 1.PROB Your Ride Is Here 1 /* 2 ID:xiekeyi1 3 PROG:ride 4 LANG:C++ 5 */ 6 7 #include<bits/stdc++.h> 8 using namespace std ; 9 10 int main() 11 { 12 freopen("ride.in","r",stdin); 13 freopen(&quo

USACO Your Ride Is Here

[USACO]Your Ride Is Here It is a well-known fact that behind every good comet is a UFO. These UFOs often come to collect loyal supporters from here on Earth. Unfortunately, they only have room to pick up one group of followers on each trip. They do,

usaco月赛,2017.1总结

T1:跳舞的奶牛 大致题意:一个体积为k的舞台能够同时容纳k只奶牛一起跳舞,他们每头奶牛的跳舞时间不同,如果有一只奶牛跳完了第k+1头奶牛就会立刻上场跳舞,当所有奶牛跳完舞以后我们认为这次表演结束.现在给出奶牛个数,最多用时,每头奶牛的跳舞时间.求舞台最小为多大. 思路:本来写了个程序以为这道题很简单,刚开始排一下序然后就行了,结果交了以后发现只过了五组,然后才发现这道题不能改变顺序(所以说为什么我改变顺序了还是能过五组,usaco的数据也好水......),所以说我想到了堆,然后就用堆写了一下

插入排序的优化【不靠谱地讲可以优化到O(nlogn)】 USACO 丑数

首先我们先介绍一下普通的插排,就是我们现在一般写的那种,效率是O(n^2)的. 普通的插排基于的思想就是找位置,然后插入进去,其他在它后面的元素全部后移,下面是普通插排的代码: 1 #include<iostream> 2 #include<fstream> 3 #include<stdio.h> 4 using namespace std; 5 int a[200000]; 6 int p[200000]; 7 8 int main(){ 9 ios::sync_wi